package es.simTacticat.centralizado;
import drcl.comp.Port;
//import java.util.Hashtable;
import drcl.comp.Contract;
import java.util.Vector;

public class CentralizedServer extends drcl.inet.application.SUDPApplication
{
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3, ACCEPT = 4;
	Vector cr = new Vector();
	int syncs = 0;
	
	public CentralizedServer ()
	{
		super ();
	}
	
	public CentralizedServer (String id_)
	{
		super (id_);
	}
	
	public void send_syncro(long dst, int dport)
	{
		//debug ("Enviando sincronizacion numero "+ syncs+" al destino: "+dst);
		sendmsg(new Paquete(SINCRO, getTime()), 600/*size*/, dst, dport);
	}
	
	public void conectar (ClientRef c)
	{
		this.sleepFor(0.001);
		boolean enc = false;
		int fp = -1;
		for(int i=0; i<cr.size();i++)
		{
			ClientRef ci = (ClientRef)cr.get(i);
			if(ci.direccion == c.direccion)
			{
				enc = true;
				break;
			}
			
		}
		if (!enc) 
		{
			cr.add(c);
			debug("Acepto cliente: "+c.direccion);
			send_accept (c.direccion, c.puerto);
			sincronizar ();
		}
	}
	
	public void avanzarOp()
	{
		this.sleepFor((0.001*cr.size())+0.001);
		sincronizar ();
	}
	public void keepAlive ()
	{
		
	}
	
	public void esperar ()
	{
		sleepFor (3);
		debug ("******************************************************");
		debug ("******************************************************");
	}
	
	public void sincronizar ()
	{
		syncs ++;
		sleepFor (0.001*cr.size());
		for (int i = 0; i < cr.size(); i++)
		{
			
			ClientRef c = (ClientRef)cr.get(i);
			send_syncro(c.direccion, c.puerto);
		}
	}
	
	public void send_accept (long dst, int port)
	{
		sleepFor (0.005);
		sendmsg(new Paquete(ACCEPT,getTime()), 400/*size*/, dst, port);		
	}
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		ClientRef c = new ClientRef (getPeerAddress(data_), getPeerPort(data_));
		Paquete pkt = (Paquete)getContent(data_);
		
		if (pkt.type == CONNECT)
		{
			conectar (c);
			
		}
		if (pkt.type == OP)
		{
			avanzarOp ();
		}
		if (pkt.type == KEEPALIVE)
		{
			keepAlive ();
		}
	}

}
