package es.simTacticat.distributed;

import java.util.Vector;

import drcl.comp.Port;
import es.simTacticat.distributed.MasterRef;
import es.simTacticat.distributed.Paquete;

public class ServerDistributed extends drcl.inet.application.SUDPApplication
{
	
	final static int CONNECT = 0, OP = 1, OP_LIGERA=5, 	RESP = 2, SINCRO = 3, ACCEPT = 4;
	//ThreadServer ts;
	//ClientRef cr[] = new ClientRef[50];
	Vector cr = new Vector();
	int syncs = 0;
	MasterRef master;
	
	public ServerDistributed ()
	{
		super ();
	}
	
	public ServerDistributed (String id_)
	{
		super (id_);
	}
	
	public void send_accept (long dst, int port)
	{
		sendmsg(new Paquete(ACCEPT,getTime()), 400/*size*/, dst, port);		
	}

	public void init(long dst_, int port_)
	{
		master = new MasterRef(dst_, port_);
		send_connect (master.direccion, master.puerto);
	}
	
	public void send_connect (long dst, int port)
	{
		//this.sleepFor(0.005);
		//debug ("sending connect");
		sendmsg (new Paquete (CONNECT, getTime ()), 250, master.direccion, master.puerto);
		
	}
	
	public void avanzarOp()
	{
		
		this.sleepFor((0.001*Math.random()));
		sincronizar (getTime());
		sendmsg(new Paquete(OP, getTime()), 250, master.direccion, master.puerto);
	}
	
	public void sincronizar (double t)
	{
		debug ("RECIBIDA SINCRONIZACION");
		this.sleepFor(0.001*cr.size()*Math.random());
		for (int i = 0; i < cr.size(); i++)
		{
			syncs ++;
			ClientRef c = (ClientRef)cr.get(i);
			send_syncro(c.direccion, c.puerto, t);
		}
	}
	
	public void send_syncro(long dst, int dport, double t)
	{
		//debug ("Enviando sincronizacion numero "+ syncs+" al destino: "+dst);
		sendmsg(new Paquete(SINCRO, (getTime()-t)), 600/*size*/, dst, dport);
		//debug("Sincronizando a "+dst);
	}
	
	public void conectar (ClientRef c)
	{
		this.sleepFor(0.001);
		boolean enc = false;
		for(int i=0; i<cr.size();i++)
		{
			ClientRef ci = (ClientRef)cr.get(i);
			if(ci.direccion == c.direccion)
			{
				enc = true;
				break;
			}
			
		}
		if (!enc) 
		{
			cr.add(c);
			debug("Acepto cliente: "+c.direccion);
			send_accept (c.direccion, c.puerto);
		}
	}
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		ClientRef c = new ClientRef (getPeerAddress(data_), getPeerPort(data_));
		Paquete pkt = (Paquete)getContent(data_);
		
		if (pkt.type == CONNECT)
		{
			conectar (c);
		}
		if (pkt.type == OP)
		{
			avanzarOp ();
		}
		if (pkt.type == OP_LIGERA)
		{
			sleepFor (0.002*Math.random());
			double time= getTime()-pkt.time;
			debug ("OP_LIGERA: " +(time*1000));
			debug("Operación ligera atendida.");
			//sendmsg(new Paquete(OP, getTime()), 300, master.direccion, master.puerto);
		}
		if (pkt.type == ACCEPT)
		{
			send_accept (c.direccion,c.puerto);
		}
		if (pkt.type == SINCRO)
		{
			double time= getTime()-pkt.time;
			//debug ("SINCRO: " +time);
			sincronizar (time);
		}
			
	}
}
