package es.simTacticat.forwarder;

import java.util.Vector;
import drcl.comp.Contract;
import drcl.comp.Port;

public class ServerForwarder extends drcl.inet.application.SUDPApplication
{
	
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3,
	ACCEPT = 4, ADD = 5, OPADV = 6;
	//ThreadServer ts;
	//ClientRef cr[] = new ClientRef[50];
	Vector cr = new Vector();
	int syncs = 0;
	MasterRef master;
	
	
	
	public ServerForwarder ()
	{
		super ();
	}
	
	public ServerForwarder (String id_)
	{
		super (id_);
	}
	
	
	public void init(long dst_, int port_)
	{
		master = new MasterRef(dst_, port_);
		send_connect (master.direccion, master.puerto);
	}
	
	public void send_connect (long dst, int port)
	{
		//this.sleepFor(0.005);
		//debug ("sending connect");
		sendmsg (new Paquete (CONNECT, getTime (), 0), 250, dst, port);
		
	}
	
	
	public void conectar (ClientRef c)
	{
		//this.sleepFor(0);
		//debug("A");
		boolean enc = false;
		for(int i=0; i<cr.size();i++)
		{
			ClientRef ci = (ClientRef)cr.get(i);
			if(ci.direccion == c.direccion)
			{
				enc = true;
				//debug ("Cliente existente");
				break;
			}
			
		}
		//debug("A");
		if (!enc) 
		{
			cr.add(c);
			//debug("Acepto cliente: "+c.direccion);
			send_accept (c.direccion, c.puerto);
			send_add (master.direccion, master.puerto);
			//sincronizar ();
		}
	}
	
	public void send_add (long dst, int port)
	{
		//this.sleepFor(0.005);
		sendmsg(new Paquete(ADD,getTime(), 0), 400/*size*/, dst, port);
	}
	
	public void avanzarOp()
	{
		send_op (master.direccion, master.puerto);
	}
	public void send_op (long dst, int port)
	{
		//debug ("Sending operation");
		sendmsg (new Paquete (OP, getTime (), 0), 300, dst, port);
	}
	public void sincronizar (double t2)
	{
		//this.sleepFor(0.400);
		for (int i = 0; i < cr.size(); i++)
		{
			syncs ++;
			ClientRef c = (ClientRef)cr.get(i);
			send_syncro(c.direccion, c.puerto, t2);
		}
	}
	

	
	public void send_accept (long dst, int port)
	{
		sendmsg(new Paquete(ACCEPT,getTime(), 0), 400/*size*/, dst, port);		
	}
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		ClientRef c = new ClientRef (getPeerAddress(data_), getPeerPort(data_));
		Paquete pkt = (Paquete)getContent(data_);
		
		if (pkt.type == CONNECT)
		{
			conectar (c);			
		}
		if (pkt.type == OP)
		{
			avanzarOp ();
		}
		if (pkt.type == SINCRO)
		{
			//debug  ("Rebibo sincronizacion "+syncs+" de "+c.direccion);
			double tiempo = getTime() - pkt.time;
			sincronizar (tiempo);
		}
		if (pkt.type == ACCEPT)
		{
			this.sleepFor(0.001);
			sincronizar (0);
		}
	}
	public void send_syncro(long dst, int dport, double t2)
	{
		//debug ("Enviando sincronizacion numero "+ syncs+" al destino: "+dst);
		sendmsg(new Paquete(SINCRO, getTime(),t2), 600/*size*/, dst, dport);
	}
}
