package es.simTacticat.replicated;

import java.util.Vector;

import drcl.comp.Port;
import es.simTacticat.replicated.ClientRef;
import es.simTacticat.replicated.Paquete;

public class ServerReplicated extends drcl.inet.application.SUDPApplication
{
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3, ACCEPT = 4, JOIN=5, JOINED=6;
	Vector cr = new Vector();
	Vector sr = new Vector ();
	int syncs = 0;
	double time=0.0;
	boolean master = false;
	/** constructor **/
	public ServerReplicated ()
	{
		super ();
	}
	/** Constructor **/
	public ServerReplicated (String id_)
	{
		super (id_);
	}
	/** Activa el flag de master **/
	public void setMaster ()
	{
		master=true;
	}
	/**
	 *  Envía un mensaje de sincronización
	 *  @param dst direccion destino
	 *   @param port puerto destino
	 *   **/
	public void send_syncro(long dst, int dport)
	{
		//debug ("Enviando sincronizacion numero "+ syncs+" al destino: "+dst);
		Paquete pkt = new Paquete (SINCRO,getTime());
		pkt.time2=this.time;
		sendmsg(pkt, 600/*size*/, dst, dport);
	}
	/**
	 * Envía un mensaje de join al grupo de servidores
	 * @param dst direccion
	 * @param port puerto
	 */
	public void send_join(long dst, int port)
	{
		ClientRef server = new ClientRef (dst, port);
		sr.add(server);
		debug ("Join al grupo de servidores");
		sendmsg(new Paquete(JOIN, getTime()),400, dst, port);
	}
	public void conectar (ClientRef c)
	{
		this.sleepFor(0.001);
		boolean enc = false;
		int fp = -1;
		for(int i=0; i<cr.size();i++)
		{
			ClientRef ci = (ClientRef)cr.get(i);
			if(ci.direccion == c.direccion)
			{
				enc = true;
				break;
			}
			
		}
		if (!enc) 
		{
			cr.add(c);
			//debug("Acepto cliente: "+c.direccion);
			send_accept (c.direccion, c.puerto);
			sincronizar ();
		}
	}
	
	public void avanzarOp()
	{
		this.sleepFor((0.001*cr.size())+(((Math.random()*System.currentTimeMillis())%1000)/100000));
		sincronizar ();
	}
	/** 
	 * Añadir un servidor al grupo de comunicaciones
	 * @param sr
	 */
	public void join (ClientRef sr)
	{
		this.sr.add(sr);
	}
	
	public void esperar ()
	{
		sleepFor (3);
		debug ("******************************************************");
		debug ("******************************************************");
	}
	
	public void sincronizar ()
	{
		syncs ++;
		this.sleepFor((0.001*cr.size())+(((Math.random()*System.currentTimeMillis())%1000)/100000));
		for (int i = 0; i < cr.size(); i++)
		{
			
			ClientRef c = (ClientRef)cr.get(i);
			send_syncro(c.direccion, c.puerto);
		}if (master)
		{
			for (int i = 0;i<sr.size();i++)
			{
				ClientRef c = (ClientRef)sr.get(i);
				send_syncro(c.direccion,c.puerto);
			}
		}
	}
	public void send_accept (long dst, int port)
	{
		this.sleepFor((0.001*cr.size())+(((Math.random()*System.currentTimeMillis())%1000)/100000));
		sendmsg(new Paquete(ACCEPT,getTime()), 400/*size*/, dst, port);		
	}
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		ClientRef c = new ClientRef (getPeerAddress(data_), getPeerPort(data_));
		Paquete pkt = (Paquete)getContent(data_);
		
		if (pkt.type == CONNECT)
		{
			conectar (c);
		}
		if (pkt.type == OP)
		{
			avanzarOp ();
		}
		if (pkt.type == JOINED)
		{
			join (c);
		}
		if (pkt.type==JOIN)
		{
			join(c);
			send_joined (c);
		}
		if (pkt.type == SINCRO)
		{
			this.time = getTime()-pkt.time;
			sincronizar ();
		}
			
	}
	public void send_joined (ClientRef c)
	{
		sendmsg(new Paquete(JOINED,getTime()), 400, c.direccion, c.puerto);
	}
}
